/* A silly little calculator implemented in Object Rexx using
   Java components for the UI. 2001-05-02, 2003-01-23, ---rgf
   ("bsf\samples\bsh\calculator.js" served as an example)       */

if      BsfInvokedBy()=1 then say "This Rexx program was invoked by Java!"
else if BsfInvokedBy()=2 then say "This Rexx program was invoked by Rexx, JVM loaded by Rexx!"
else                          say "No JVM present, we got troubles ..."


.bsf~import("awtFrame",         "java.awt.Frame")
.bsf~import("awtTextField",     "java.awt.TextField")
.bsf~import("awtPanel",         "java.awt.Panel")
.bsf~import("awtLabel",         "java.awt.Label")
.bsf~import("awtGridLayout",    "java.awt.GridLayout")

f =  .awtFrame~new("str", "BSH Calculator")
f~bsf.addEventListener("window", "windowClosing", "call bsf 'exit'")

f1 = .awtTextField~new("int", 20)
f1~bsf.addEventListener("action", "", "call doMath /* action event */")

f2 = .awtTextField~new("int", 20)
f2~bsf.addEventListener("text", "", "call doMath /* text event */")

p =  .awtPanel~new ~~setLayout("obj", .awtGridLayout~new("int", 2, "int", 2))
p ~~add("obj", .awtLabel~new("str", "Enter operand")) ~~add("obj", f1)
p ~~add("obj", .awtLabel~new("str", "Enter operand")) ~~add("obj", f2)

f~add("str", "North",  "obj", p)
f~add("str", "Center", "obj", .awtLabel~new("str", "Results:"))


p =  .awtPanel~new ~~setLayout("obj", .awtGridLayout~new("int", 4, "int", 2))

sum= .awtTextField~new("int", 20)
p ~~add("obj", .awtLabel~new("str", "Sum"          )) ~~add("obj", sum)

diff= .awtTextField~new("int", 20)
p ~~add("obj", .awtLabel~new("str", "Difference"   )) ~~add("obj", diff)

prod= .awtTextField~new("int", 20)
p ~~add("obj", .awtLabel~new("str", "Product"      )) ~~add("obj", prod)

quo = .awtTextField~new("int", 20)
p ~~add("obj", .awtLabel~new("str", "Sum"          )) ~~add("obj", quo)

f ~~add("str", "South", "obj", p) ~~pack ~~show ~~toFront

do forever
   a=bsf("pollEventText")
   say "... received: ["a"]"
   interpret a
end
exit

getField: procedure
   parse arg f
   t=bsf("invoke", f, "getText")
   if t="" then return 0
   return t

doMath:
   n1 = getField(f1); if n1="-" then n1=-1;else if n1="+" then n1=1
   n2 = getField(f2); if n2="-" then n2=-1;else if n2="+" then n2=1
   sum ~setText("str", n1+n2)
   diff~setText("str", n1-n2)
   prod~setText("str", n1*n2)
   if n2=0 then quo~setText("str", "DIVISION by 0 !!!")
           else quo~setText("str", n1/n2)
   return

::requires "BSF.cls"    -- get Object Rexx wrapper support
